import Client from "mtproton/envs/browser";
import between from "./utils/rand";
import exp from "constants";

class TelegramHelper {
  private client: any;
  constructor(appID: number, appHash: string) {
    this.client = new Client({
      api_id: appID,
      api_hash: appHash,
      test: true,
    });
  }

  // @ts-ignore
  async call(method: string, params?: object, options?: object) {
    try {
      return await this.client.call(method, params, options);
    } catch (error) {
      console.log(`${method} error:`, error);

      // @ts-ignore
      const { error_code, error_message } = error;

      // if (error_code === 420) {
      //   const seconds = Number(error_message.split('FLOOD_WAIT_')[1]);
      //   const ms = seconds * 1000;
      //
      //   await sleep(ms);
      //
      //   return this.call(method, params, options);
      // }

      if (error_code === 303) {
        const [type, dcIdAsString] = error_message.split("_MIGRATE_");

        const dcId = Number(dcIdAsString);

        if (type === "PHONE") {
          await this.client.setDefaultDc(dcId);
        } else {
          Object.assign(options, { dcId });
        }

        return this.call(method, params, options);
      }

      return Promise.reject(error);
    }
  }
}

async function uploadBigFile(bytes: string): Promise<number> {
  let file_id = between(10000, 99999);
  console.log("file_id", file_id);

  const file_total_parts = Math.ceil(bytes.length / 524288);
  console.log("file_total_parts", file_total_parts);
  for (let i = 0; i < file_total_parts; i++) {
    console.log("push part: ", i);
    try {
      let finished = await Telegram.call("upload.saveBigFilePart", {
        file_id: file_id,
        file_part: i,
        file_total_parts: file_total_parts,
        bytes: bytes.slice(i * 524288, (i + 1) * 524288),
      });
      if (finished) {
        console.log("finished");
      } else {
        console.log("not finished");
      }
    } catch (error) {
      return Promise.reject(error);
    }
  }

  console.log("uploaded");
  return file_id;
}

const appID = 18987971;
const appHash = "fcfd9e6ed3f9e48a360bb57cc0d59d98";
let Telegram = new TelegramHelper(appID, appHash);

export default Telegram;
export { uploadBigFile };
